DROP VIEW V_RESERVATIONS_MANAGEMENT;

CREATE OR REPLACE VIEW V_RESERVATIONS_MANAGEMENT AS 
(
SELECT 'ALARM_ARRIVAL' AS CATEGORY, CONCAT('ALARM_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)) 
ELSE RE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) < TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2 AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE < RE.DATUM_REZERVACIJE AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC IN (1,2) )
UNION ALL
SELECT 'ALARM_DEPARTURE' AS CATEGORY, CONCAT('ALARM_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)) 
ELSE RE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN (CASE WHEN RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)
ELSE RE.DATUM_DO END) <= TRUNC(SYSDATE) 
AND RE.STATUS_REZERVAC IN (1,2) AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)
UNION ALL
SELECT 'ALARM_MOVE' AS CATEGORY, CONCAT('ALARM_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD <= TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'ALARM_EXIT' AS CATEGORY, CONCAT('ALARM_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'ALARM_RETURN' AS CATEGORY, CONCAT('ALARM_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 2 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'PLAN_ARRIVAL' AS CATEGORY, CONCAT('PLAN_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)) 
ELSE RE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) >= TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2
UNION ALL
SELECT 'PLAN_DEPARTURE' AS CATEGORY, CONCAT('PLAN_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)) 
ELSE RE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN (CASE WHEN RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)
ELSE RE.DATUM_DO END) >= TRUNC(SYSDATE) 
AND (RE.STATUS_REZERVAC IN (1, 2) OR (RE.STATUS_REZERVAC IN (3, 4) AND RE.VRSTA = 'RE')) AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)
AND RE.DATUM_DO = (SELECT MAX(DE2.DATUM_DO) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = DE.ID_REZERVAC AND DE2.ID_PRIVEZ = DE.ID_PRIVEZ AND DE2.STATUS_REZERVAC = DE.STATUS_REZERVAC)
AND DE.DATUM_DO = (SELECT MAX(DE2.DATUM_DO) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = DE.ID_REZERVAC AND DE2.ID_PRIVEZ = DE.ID_PRIVEZ AND DE2.STATUS_REZERVAC = DE.STATUS_REZERVAC)
UNION ALL
SELECT 'PLAN_MOVE' AS CATEGORY, CONCAT('PLAN_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND NOT EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)
UNION ALL
SELECT 'PLAN_EXIT' AS CATEGORY, CONCAT('PLAN_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N')
UNION ALL
SELECT 'PLAN_RETURN' AS CATEGORY, CONCAT('PLAN_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)
UNION ALL
SELECT 'CURRENT_PRESENT' AS CATEGORY, CONCAT('CURRENT_PRESENT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE = 'Y')
UNION ALL
SELECT 'CURRENT_EXIT' AS CATEGORY, CONCAT('CURRENT_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO,
VD.N_PRIVEZA, VD.ID_PRIVEZ, VD.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
LEFT OUTER JOIN (SELECT ID, N_PRIVEZA, ID_PRIVEZ, NNLOCATION_ID, ID_LASTNIKA, ID_PLOVILA, KATEGORIJA_DOGODKA, ROW_NUMBER() OVER (PARTITION BY ID_LASTNIKA, ID_PLOVILA, KATEGORIJA_DOGODKA ORDER BY ID DESC) RNK FROM V_DOGODKI) VD
ON (VD.ID_LASTNIKA = RE.ID_LASTNIKA AND VD.ID_PLOVILA = RE.ID_PLOVILA AND VD.RNK = 1 AND VD.KATEGORIJA_DOGODKA = 'IZ')
WHERE RE.STATUS_REZERVAC = 2 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE = 'Y')
)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2050, SYSDATE, '5.5', 1970, 'VReservationsManagement');